
/*
 *	address.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1985 by Robert Krten, all rights reserved.
 *
 *	This module contains addressing logic.
 *
 *	1985 07 20	R. Krten		created
*/

#include "pdp8i.h"

extern	char *progname;					/* main.c */
extern	char *version;					/* version.c */

ea (a)
int a;
{
	a &= 00777;						/* kill instruction field */
	showamod (a);					/* show addressing modes */
	if (a & 00400) {				/* indirect addressing */
		return (fetch (a & 00377));	/* get it and return it */
	}
	return ((a & 00177) + ((a & 00200) ? (pdp8.pc & 07600) : 0));
}

void
showamod (a)
int a;
{
	if (a & 00400) {
		addrtype = INDIRECT;
	} else {
		if (a & 00200) {
			addrtype = CURRENT;
		} else {
			addrtype = ZERO;
		}
	}
}

