
/*
 *	fetch.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1985 by Robert Krten, all rights reserved.
 *
 *	This module contains the address fetching logic.
 *
 *	1985 07 20	R. Krten		created
*/

extern	char *progname;					/* main.c */
extern	char *version;					/* version.c */

#include "pdp8i.h"

#ifdef HIF
int	oldat = 3;	/* never can, therefore regenerate */
int	atyx [4] = {8, 12, 12, 24};
#endif /* HIF */

fetch (addr)
int addr;
{
#ifdef HIF
	sat ();
	if (!optf) {
		locate (4, 71);
		pcvwca (0xdb, COLOR_STATUS);
	}
#endif /* HIF */
	addr &= 07777;
	memory [addr] &= 07777;
	pdp8.ma = addr;
	pdp8.mb = memory [addr];
#ifdef HIF
	if (!optf) {
		locate (4, 71);
		pcvwca (' ', COLOR_STATUS);
	}
#endif /* HIF */
	return (memory [addr]);
}

void
store (addr, data)
int addr;
int data;
{
#ifdef HIF
	sat ();
	if (!optf) {
		locate (4, 71);
		pcvwca (0xdb, COLOR_STATUS);
	}
#endif /* HIF */
	data &= 07777;
	addr &= 07777;
	pdp8.ma = addr;
	pdp8.mb = data;
	memory [addr] = data;
#ifdef HIF
	if (!optf) {
		locate (4, 71);
		pcvwca (' ', COLOR_STATUS);
	}
#endif /* HIF */
}

#ifdef HIF
void
sat ()
{
	if (optf) return;
	if (oldat != addrtype) {
		locate (atyx [oldat], 71);
		if (oldat == ZERO || oldat == CURRENT) {
			if (addrtype == INDIRECT) {
				pcvwca (' ', COLOR_TEXT);
				locate (atyx [addrtype], 71);
				pcvwca (0xdb, COLOR_STATUS);
			}
		} else {
			if (addrtype == ZERO || addrtype == CURRENT) {
				pcvwca (' ', COLOR_TEXT);
				locate (atyx [addrtype], 71);
				pcvwca (0xdb, COLOR_STATUS);
			}
		}
		oldat = addrtype;
	}
}
#endif /* HIF */

