
/*
 *	machine.h
 *
 *	QNX 4
 *
 *	(C) Copyright 1984 by Robert Krten, all rights reserved.
 *
 *	This module contains the PDP-8 machine definitions.
 *
 *	1984 12 23	R. Krten		created
*/

#define		RPC			0
#define		RMA			1
#define		RMB			2
#define		RAC			3
#define		RMQ			4

#define		ILINK		12
#define		ISC0		12
#define		ISC1		13
#define		ISC2		14
#define		ISC3		15
#define		ISC4		16

#define		INDIRECT	0
#define		ZERO		1
#define		CURRENT		2

#define		BIT0		00001
#define		BIT1		00002
#define		BIT2		00004
#define		BIT3		00010
#define		BIT4		00020
#define		BIT5		00040
#define		BIT6		00100
#define		BIT7		00200
#define		BIT8		00400
#define		BIT9		01000
#define		BIT10		02000
#define		BIT11		04000

struct		pdp8tag
{
	int		pc;
	int		ma;
	int		mb;
	long	ac;
	long	mq;
};

