
/*
 *	pdp8i.h
 *
 *	QNX 4
 *
 *	(C) Copyright 1988 by Robert Krten, all rights reserved.
 *
 *	This module contains the global include list.
 *
 *	1988 03 22	R. Krten		created
 *	1992 07 04	R. Krten		ported to QNX 4, included prototypes
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/qnxterm.h>

#include "machine.h"		/* headers for the main cpu */
#include "database.h"		/* externals */
#include "screen.h"			/* screen information */
#include "opr.h"			/* operate microinstructions */
#include "proto.h"

#define	COLOR_BIT			TERM_RED
#define	COLOR_BOX			TERM_BLUE
#define	COLOR_STATUS		TERM_GREEN
#define	COLOR_OPCLASS		TERM_WHITE
#define	COLOR_TEXT			TERM_CYAN

/* define	NO_HIF*/		/* removes human interface completely */
							/* useful for execute only type applications */
#define HIF			1

