
/*
 *	qnx4.c
 *
 *	QNX 4
 *
 *	(C) Copyright 1992 by Robert Krten, all rights reserved.
 *
 *	This module contains the QNX 4 screen interface.
 *
 *	1992 07 04 R. Krten		created
*/

#include <stdio.h>
#include <stdlib.h>

#include <sys/dev.h>
#include <sys/qnxterm.h>

extern	char *progname;					/* main.c */
extern	char *version;					/* version.c */

int		xloc, yloc;

void
cls ()
{
	term_clear (TERM_CLS_SCRH);
}

int
char_waiting ()
{
	return (0);
}

void
pcvwca (ch, at)
char	ch;
int		at;
{
	term_type (yloc, xloc, &ch, 1, at);
}

void
locate (y, x)
int		y;
int		x;
{
	term_cur (yloc = y, xloc = x);
}

void
OSInitDisplay ()
{
	if (term_load () == -1) {
		printf ("%s:  error loading terminal info.\n", progname);
		perror (NULL);
		exit (1);
	}
	term_video_on ();
	cls ();
}

void
OSStopDisplay ()
{
}

